﻿#!/usr/local/bin/python
# -*- coding: utf-8 -*-
import time

import ssl
import sys
import urllib2
from urlparse import parse_qsl

from resources import static
import xbmc
import xbmcaddon
import xbmcgui
import xbmcplugin

_url = sys.argv[0]
_handle = int(sys.argv[1])
_addon = xbmcaddon.Addon()
_name = _addon.getAddonInfo('name')
_icon = _addon.getAddonInfo('icon')


def play_video(link):
    """
    Play a video.
    """
    play_item = xbmcgui.ListItem(path=link)
    play_item.setInfo(type="video", infoLabels={})
    xbmcplugin.setResolvedUrl(_handle, True, listitem=play_item)


def play_ace_video(link):
    """
    Play a video.
    """
    xbmc.executebuiltin("ActivateWindow(busydialog)")
    aceurl = static.acesrv + "ace/manifest.m3u8?id=%s&format=json" % link
    try:
        data = static.download(aceurl, ret_json=True, timeout=2)
    except urllib2.URLError:
        xbmc.executebuiltin("Dialog.Close(busydialog)")
        xbmcgui.Dialog().notification(_name, u"Acestream variklis nepasiekiamas\nPatikrinkite nustatymus.",
                                      icon=xbmcgui.NOTIFICATION_WARNING)
        return

    stat_url = (data.get('response') or {}).get('stat_url')
    if stat_url:
        data = static.download(stat_url, ret_json=True)
        stat = data.get('response') or {}
        retries = 0
        while 'status' not in stat or stat.get('status') == 'idle':
            time.sleep(0.1 + (retries/3))
            data = static.download(stat_url, ret_json=True)
            stat = data.get('response') or {}
            retries += 1
            if retries > 6:
                break

        static.log("ID", link, "status", data)
        xbmc.executebuiltin("Dialog.Close(busydialog)")
        if 'peers' in stat and stat.get('peers') <= 0:
            xbmcgui.Dialog().notification(_name, u"Kanalas neturi siuntėjų")
        else:
            play_item = xbmcgui.ListItem(path=static.acesrv + 'ace/manifest.m3u8?id=' + link)
            play_item.setInfo(type="video", infoLabels={})
            xbmcplugin.setResolvedUrl(_handle, True, listitem=play_item)
    else:
        xbmc.executebuiltin("Dialog.Close(busydialog)")
        xbmcgui.Dialog().notification(_name, "Kanalas nepasiekiamas")


def list_link(link=None, menus=static.main_menu):
    """
    Opens a regular menu.
    """
    if link is not None:
        static.log("Opening link", link)
        for menu_no in link.split('.'):
            menus = menus[int(menu_no)].items
            if isinstance(menus, list):
                break
            if callable(menus):
                menus = menus()

    for i, entry in enumerate(menus):
        list_item = xbmcgui.ListItem(label=entry.label)
        # list_item.setProperty('fanart_image', menu.image)

        if isinstance(entry, static.Menu):
            link0 = i if link is None else "{}.{}".format(link, i)
            url = '{0}?action=list&link={1}'.format(_url, link0)
            xbmcplugin.addDirectoryItem(_handle, url, list_item, isFolder=True)
        elif isinstance(entry, static.Source):
            list_item.setProperty('IsPlayable', 'true')
            list_item.setInfo("video", {'title': entry.label})
            url = entry.link
            if isinstance(entry, static.AceIdVideo):
                url = '{0}?action=playAce&link={1}'.format(_url, entry.acelink)
            xbmcplugin.addDirectoryItem(_handle, url, list_item, isFolder=False)
        else:
            continue
    xbmcplugin.endOfDirectory(_handle)


def router(paramstring):
    """
    Router function that calls other functions
    depending on the provided paramstring
    """
    # Parse a URL-encoded paramstring to the dictionary of
    # {<parameter>: <value>} elements
    params = dict(parse_qsl(paramstring))
    if params:
        if params['action'] == 'list':
            # Display the list of menus in a provided in static.py.
            list_link(params['link'])

        elif params['action'] == 'play':
            # Play a video from a provided URL.
            play_video(params['link'])

        elif params['action'] == 'playAce':
            # Play a video from a provided URL.
            play_ace_video(params['link'])

        elif params['action'] == 'dialog':
            xbmcgui.Dialog().notification(_name, params['text'], icon=xbmcgui.NOTIFICATION_WARNING)

    else:
        # If the plugin is called from Kodi UI without any parameters,
        # display the list of video categories
        list_link()


if __name__ == '__main__':
    try:
        router(sys.argv[2][1:])
    except urllib2.HTTPError as e:
        xbmcgui.Dialog().notification(_name, "Jungimosi klaida {}".format(e.code))

    except urllib2.URLError as e:
        xbmcgui.Dialog().notification(_name, "Nepavyko prisijungti.", str(e.reason))

    except ssl.SSLError as e:
        if e.message == 'The read operation timed out':
            xbmcgui.Dialog().notification(_name, "Puslapis negražino atsakymo", "Bandykite vėliau",
                                          icon=xbmcgui.NOTIFICATION_ERROR)
        else:
            xbmcgui.Dialog().notification(_name, "Jungimosi klaida!", e.message)

